	// Delcarations
	var geocoder;
	var map;
	var previousPosition = null;
	var currentPositionMarker = null;
	var geolocalisationActivee = null;
	var directionsDisplay;
	var directionsService = new google.maps.DirectionsService();
	
	var markers = new Array();
	var gpsMarker;
	var infoBulle;
	var open = false;
	var t;
	
	
	// Actions
	 
	
	/**
	* Cette fonction permet d'initialiser la carte Google Maps 
	*/
	function initialize() {
		directionsDisplay = new google.maps.DirectionsRenderer();

		/** 
		* Cette variable permet de positionner un point sur la carte en fonction de
		* la longitude et de la latitude
		*/
		var myLatlng = new google.maps.LatLng(48.858565, 2.347198);
		
		/**
		* Cette variable permet de donner des options à la carte (zoom et centrage de 
		* la carte en fonction de la variable myLalng 
		*/
		var mapOptions = {
			zoom: 4,
			center: myLatlng,
			mapTypeId: 'roadmap'
		};

		/**
		* La carte se mettra au niveau de l'élemnent placé en paramètre 
		*/
		map = new google.maps.Map(document.getElementById('map-canvas'), mapOptions);
		
		ajoutPanelItineraire ();
		ajouterElementSurCarte();
	}
	
	/**
	 * Cette fonction permet d'affciher une fenêtre indiquant le trajet à 
	 * suivre pour arriver à destination.
	 */
	function ajoutPanelItineraire(){
		directionsDisplay.setMap(map);
		directionsDisplay.setPanel(document.getElementById('directions-panel'));
	}
	
	/**
	 * Cette fonction permet d'ajouter des élements à la carte comme des
	 * boutons, boites de texte, etc.
	 */
	function ajouterElementSurCarte (){
		var control = document.getElementById('control');
		control.style.display = 'block';
		map.controls[google.maps.ControlPosition.TOP_LEFT].push(control);
		
		var afficherPositionCourante = document.getElementById('position');
		afficherPositionCourante.style.display = 'block';
		map.controls[google.maps.ControlPosition.RIGHT_BOTTOM].push(afficherPositionCourante);
	}

	/**
	 * Cette fonction permet de faire de l'autocomplétion 
	 */
	function autoCompletion (id){
		// on récupère l'élement texte qui nous intéresse (placé en paramètre)
		var input = /** @type {HTMLInputElement} */(
		document.getElementById(id));
		
		// on met sur l'élément texte les propositions faites à partir de la carte
		var autocomplete = new google.maps.places.Autocomplete(input);
		autocomplete.bindTo('bounds', map);
		
		// Si l'identifiant est égal à lieu alors, on va centrer la carte sur le lieu renseigné
		if (id == "lieu"){
			google.maps.event.addListener(autocomplete, 'place_changed', function() {
				var place = autocomplete.getPlace();
				if (!place.geometry) {
					return;
				}
				else {
					operationsPourMarker (place.address_components);
					map.setCenter(place.geometry.location);
					map.setZoom(12);
				}
			});
		}
	}
	
	/**
	 * Cette fonction permet de récupérer la ville
	 */
	function obtenirVille (lieuCentre){
		for (i in lieuCentre){
			if (lieuCentre[i].types[0] == 'locality'){
				return lieuCentre[i].long_name;
			}
		}
	}
	
	/**
	 * Cette fonction permet de réaliser les actions qui permettront de créer des marqueurs
	 * par rapport à une ville
	 */
	function operationsPourMarker (lieuCentre){
		var ville = obtenirVille(lieuCentre);
		obtenirParkings (ville);
	}
	
	/**
	 * Cette fonction permet de récupérer les parkings à partir de la BDD
	 * grâce à l'ajax
	 */
	function obtenirParkings (ville){
		var data;
		
		if(ville != null)
		{
			// on renseigne la valeur de la ville dont la valeur est en paramètre
			var parameters={ville: ville};
			
			// appel à l'ajax pour récupérer touts les parings d'une ville
			$.ajax({type: 'post', dataType: 'json', url: 'recupererParkingsParVille.php', data: parameters, success: placerMarkers});
		}
	}
	
	/**
	 * Cette fonction permet de placer des marqueurs sur une carte grâce aux données
	 * obtenues par le paramètre data.
	 */
	function placerMarkers(data){
		// On efface les marqueurs
		for (i in markers){
			markers[i].setMap(null);
		}
		// réinitialisation du tableau de marqueurs
		markers = new Array();
		
		if (data != null){
			for (i in data){
				// Placement des markers
				setMarker(i, data[i].latitude, data[i].longitude);
				// on met les infos bulle associées
				setInfoWindow (i, data[i].idParking);
			}
		}
	}
	
	/**
	* Cette fonction permet de placer un marqueur sur la carte en ayant un icone particulier
	* Elle rajoute également une "infobox" contenant une chaine de caractère "text".
	*/
	function setMarker(i, latitude, longitude) {
		var image = '/AAP/images/parking_marqueur.png';
		var myLatLng = new google.maps.LatLng(latitude, longitude);
		markers[i] = new google.maps.Marker({
			position: myLatLng,
			map: map,
			icon: image
		});
	}
	
	/**
	 * Cette fonction permet de créer une infoBulle avec les informations du parking.
	 */
	function setInfoWindow (i, idParking){	
		chaine = ""; 
		markers[i]['infoWindow'] = new google.maps.InfoWindow({
				content: chaine
		});
		
		google.maps.event.addListener(markers[i], 'closeclick', function() {
			//alert("je ferme");
			for (j in markers){
					clearRefreshDiv(t);
			}
		});	
		
		
		google.maps.event.addListener(markers[i], 'click', function() {
				for (j in markers){
					if (j != i){
						markers[j]['infoWindow'].close();
					}
				}
				markers[i]['infoWindow'].open(map,markers[i]);
				recupInformationsInfoBulle(idParking);
				markers[i]['infoWindow'].setContent (infoBulle);
				if (!open){
					t = refresh_div();
					open = true;
				}
		});
	}
	
	
	/**
	 * Cette fonction permet de renvoyer sous forme de chaine les informations d'un parking
	 * en les récupérant de la bdd en passant par Ajax
	 */
	function recupInformationsInfoBulle (idParking){
		if (idParking != null){
			var parameters={idParking: idParking};
			$.ajax({async: false, type: 'post', url: 'changerInfos.php', data: parameters, success: changerInfosInfoBulle});
		}
	}
	
	
	/**
	 * Cette fonction permet de renseigner l'infoBulle
	 */
	function changerInfosInfoBulle (chaine){
		if (chaine != null){
			infoBulle = chaine;
		}
	}
	
	/**
	 * Cette fonction permet de calculer le trajet entre deux points départ et arrivée
	 */ 
	function calcRoute() {
		var start = document.getElementById('depart').value;
		var end = document.getElementById('arrivee').value;
		var request = {
			origin: start,
			destination: end,
			travelMode: google.maps.TravelMode.DRIVING
		};
		directionsService.route(request, function(response, status) {
		if (status == google.maps.DirectionsStatus.OK) {
			directionsDisplay.setDirections(response);
		}
		});
	}
	
	/**
	 * Cette fonction permet de prendre en compte la géolocalisation.
	 */
	function priseEnCompteGeolocalisation (){
		geolocalisationActivee = !geolocalisationActivee;
		if (geolocalisationActivee){
			if (navigator.geolocation)
			{
				var watchId = navigator.geolocation.watchPosition(successCallback, null, {enableHighAccuracy:true});
			}
			else
			{
				alert("Votre navigateur ne prend pas en compte la géolocalisation HTML5");
			}
		}
		else {
			//currentPositionMarker.setVisible(false);
			currentPositionMarker.setMap(null);
			currentPositionMarker = null;
		}
	}
	
	/**
	 * Fonction qui permet de récupérer la psoition. Afficher et centrer avec un marqueur
	 * ou faire disparaître le marqueur et ne pas centrer
	 */
	function successCallback(position){
		// S'il y a la geolocalisation
		if (geolocalisationActivee){
			// Si le marqueur est null, on lui attribut la valeur de la position geographique de l'utilisateur
			if (currentPositionMarker == null){
				currentPositionMarker = new google.maps.Marker({
					position: new google.maps.LatLng(position.coords.latitude, position.coords.longitude),
					map: map
				});
			}
			else {
				// On change la position du marqueur en fonction de la position geographique de l'utilisateur
				currentPositionMarker.setPosition(new google.maps.LatLng(position.coords.latitude, position.coords.longitude));
				currentPositionMarker.setVisible(true);
			}
			// On centre la carte sur le marqueur
			map.panTo(new google.maps.LatLng(position.coords.latitude, position.coords.longitude));
		}
		
		previousPosition = position;
    }	
	
	google.maps.event.addDomListener(window, 'load', initialize);