/**
 * Cette fonction permet de calculer la distance entre deux points sur une carte en connaissant 
 * la latitude, la longitude et l'altitude de chaque point.
 */
function distance($lat1, $lon1, $lat2, $lon2, $alt1, $alt2) {
	// On définit le rayon de la terre
	$r = 6371;
	
	// On convertit en degré radian la latitude et la longitude de chaque point
	$lat1 = deg2rad($lat1);
	$lat2 = deg2rad($lat2);
	$lon1 = deg2rad($lon1);
	$lon2 = deg2rad($lon2);

	// on récupère l'altitude en km
	$alt1 = $alt1/1000;
	$alt2 = $alt2/1000;

	//calcul de la distance angulaire en radian
	$dp= 2 * asin(sqrt(pow (sin(($lat1-$lat2)/2) , 2) + cos($lat1)*cos($lat2)* pow( sin(($lon1-$lon2)/2) , 2)));

	// Obtention de la distance en multipliant par le rayon de la terre
	$d = $dp * $r;

	//Calcul de la distance en prenant en compte les altitudes
	 $h = sqrt(pow($d,2)+pow($alt2-$alt1,2));

	return $h;
}