var plan;
var tabgrid;
var infoPlace;
var idParking;
var idCasePlace;

/**
 * Cette fonction permet d'afficher le parking cr s'il existe, sinon en cre un nouveau
 */
 function afficherOuCreerGrille (){
	idParking = document.getElementById("idParking").innerHTML;
	recupererInformationsBDD();
	creationGrille(true);
	var type;
	var i;
	if (!plan['vide']){
		//Sinon, on affiche le tableau dj prsent
		for (i=0;i<plan['champs'].length;i++) {
			id = plan['champs'][i]['numeroLigne']+"_"+plan['champs'][i]['numeroColonne'];
			if (plan['champs'][i]['idType'] == 1){
				type = "route";
			}
			else if (plan['champs'][i]['idType'] == 2){
				type = "place";
			}
			else {
				type = "autre";
			}
			modifierAspect(id, type);
		}	
	}
 } 
 
 /**
 * Cette fonction permet de rcuprer les informations de la BDD
 */ 
 function recupererInformationsBDD (){
	var parameters = {idParking: idParking};

	// appel  l'ajax pour mettre  jour la BDD
	$.ajax({async: false, type: 'post', dataType: 'json', url: 'recupPlanParking.php', data: parameters, success: setPlan});		
 }
 
 /**
  * Cette fonction permet de mettre les valeurs du tableau dans plan
  */
function setPlan(data){
	plan = data;
}

/**
 * Cette fonction permet de mettre  jour le tableau
 */
 function preparationTableau (){
	 //Ajout d'une ligne dans le tableau principal
	var rowAffGrid=document.getElementById("tabJeu").insertRow(1);
	
	//Ajout d'une cellule d'affichage dans la ligne cre
	var cellAffGrid=rowAffGrid.insertCell(0);
	
	//La cellule s'tend sur toute la largeur du tableau principal
	cellAffGrid.colSpan=2;
	
	//Cration du tableau HTML destin  l'affichage de la grille de jeu
	tabgrid=document.createElement("table");
	with (tabgrid) {
		width="100%";
		id="tabgrid";
		cellSpacing=1;
	}
	//Ajout du tableau HTML aux noeuds enfants de la cellule d'affichage
	cellAffGrid.appendChild(tabgrid);
 }
  
/**
 * Cette fonction permet de crer une grille (plan de parking quadrill)
 */ 
function creationGrille(configurateur) {
	var indexColonne=0;
	var indexLigne=0;
	   
	var nbLignes = document.getElementById("nbLignes").value;
	var nbColonnes = document.getElementById("nbColonnes").value;

	//Recherche du tableau HTML de la grille d'affichage
	//Si la grille existe elle est vide
	if (document.getElementById("tabgrid")!=null) {
		tabgrid=document.getElementById("tabgrid");
		for (indexLigne=tabgrid.rows.length-1;indexLigne>=0;indexLigne--) {
			tabgrid.deleteRow(indexLigne);
		}
	}
	//Sinon elle est cr
	else {
		//Preparatio duTableau
		preparationTableau();
	}
	
	//redimensionnement en largeur
	document.getElementById("tabJeu").style.width=eval(nbLignes*30)+"px";
	
	if (configurateur){
		//Remplissage du tableau HTML
		for (indexLigne=0;indexLigne<nbLignes;indexLigne++) {
			var rowGrid=tabgrid.insertRow(indexLigne);
			rowGrid.style.height="29px";
			for (indexColonne=0;indexColonne<nbColonnes;indexColonne++) {
				var cellGrid=rowGrid.insertCell(indexColonne);
				var idCell=indexLigne+"_"+indexColonne;
				with (cellGrid){
					id=idCell;
					title="L"+(indexLigne+1)+"C"+(indexColonne+1);
					className="cellgrid";
				}
				document.getElementById(idCell).setAttribute("onclick","visualisationOuMiseAJourCelluleGrille('"+idCell+"')");
			}
		}
		afficheMenu();
		miseAJourPlanParking (nbLignes, nbColonnes);
	}
	else {
		//Remplissage du tableau HTML
		for (indexLigne=0;indexLigne<nbLignes;indexLigne++) {
			var rowGrid=tabgrid.insertRow(indexLigne);
			rowGrid.style.height="29px";
			for (indexColonne=0;indexColonne<nbColonnes;indexColonne++) {
				var cellGrid=rowGrid.insertCell(indexColonne);
				var idCell=indexLigne+"_"+indexColonne;
				with (cellGrid){
					id=idCell;
					title="L"+(indexLigne+1)+"C"+(indexColonne+1);
					className="cellgrid";
				}
			}
		}
	}
} 

/**
 * Cette fonction permet d'affciher le menu correspondant  celui dont le 
 * bouton radio a t slectionn
 */
function afficheMenu(){
	var type; 
	type = recupererType ();
	var form_d = "";
	if (type == "place"){
		form_d = '<label for="idCapteur">ID du capteur correspondant :</label><input type="text" id="idCapteur" /><br /> ' 
					+ '<label for="idPlace">ID de la place :</label><input type="text" id="idPlace" /><br /> ' 
					+ '<label for="morphologie">Morphologie :</label><select id="morphologie" name="morphologie" >'
																			 + ' <OPTION>petite '
																			 + ' <OPTION>moyenne '
																			 + ' <OPTION>grande '
																	 + '</select> <br />'
					+ '<label for="type">Type de place :</label><select id="type" name="type" >'
																			 + ' <OPTION>creneau '
																			 + ' <OPTION>bataille '
																			 + ' <OPTION>epis '
																	 + '</select> <br />'
					+ '<label for="type">Type de place :</label><INPUT type="checkbox" name="choix1" id="handicapee" value="handicapee" > place handicape <br />'
					+ '<input type="button" onclick="miseAJourGrille();" value="Modifier"/>';
	}
	else {
		form_d = "";
	}
	document.getElementById("menu").innerHTML = form_d;
}

/**
 * Cette fonction permet de renvoyer le type qui a t slectionn
 * par le bouton radio
 */ 
function recupererType (){
	var type;
	if (document.getElementById("route").checked) {
		type="route";
	}
	else if (document.getElementById("place").checked) {
		type="place";
	}
	else {
		type="autre";
	}
	return type;
}


/**
 * Cette fonction permet de visualiser la config qui a t enregistre
 */ 
 function visualisationOuMiseAJourCelluleGrille (id){
	//Slection du type de case (route, autre ou place)
	var type = recupererType();
	 
	// On renseigne la place renseign en variable globale
	idCasePlace = id;
	 
	if (type == "place"){		
		// recuperer informations dans la bdd la BDD
		var indexes=id.split("_");
		var numeroLigne=indexes[0];
		var numeroColonne=indexes[1];
		var parameters = {idParking: idParking, nbreLigne: numeroLigne, nbreColonne: numeroColonne};
		
		// appel  l'ajax pour mettre  jour la BDD
		$.ajax({type: 'post', dataType: 'json', url: 'recupConfigCelulle.php', data: parameters, success: afficherConfig});
	}	
	else {
		miseAJourGrille ();
	}
 }
 
 /**
  * Cette fonction permet d'afficher la configuration d'une cellule
  */
  function afficherConfig (data){
	if (data['handicapee'] == "1"){
		document.getElementById("handicapee").checked = true;
	}
	else {
		document.getElementById("handicapee").checked = false;
	}
	
	// Permet d'afficher dans les champs associs, la configuration de la case
	document.getElementById("type").value = data['typePlace'];
	document.getElementById("morphologie").value = data['morphologie'];
	document.getElementById("idPlace").value = data['idPlace'];
	document.getElementById("idCapteur").value = data['idCapteur'];
  }
 
 /**
  * Cette fonction permet de modifier l'aspect des celulles
  */ 
 function modifierAspect(id, type){
	// Dfinition de l'aspect de la celulle
	var cellplay=document.getElementById(id);
	if (type=="route") {
		// Aspect de la celulle
		with (cellplay) {
			className="cellRoute";
			innerHTML="";
		}
	}
	else if (type=="place") {
		// Aspect de la celulle
		with (cellplay) {
			className="cellPlace";
			innerHTML="";
		}
	}
	else if (type=="autre") {
		// Aspect de la celulle
		with (cellplay) {
			className="cellAutre";
			innerHTML="";
		}
	}
	else if (type=="placeLibre"){
		// Aspect de la celulle
		with (cellplay) {
			className="cellPlaceLibre";
			innerHTML="";
		}
	}
	else if (type=="placeOccupee"){
		// Aspect de la celulle
		with (cellplay) {
			className="cellPlaceOccupee";
			innerHTML="";
		}
	}
	else if (type=="placeHandicapeeLibre"){
		// Aspect de la celulle
		with (cellplay) {
			className="cellPlaceHandicapeeLibre";
			innerHTML="";
		}
	}
 }
 
/**
 * Cette fonction permet de mettre  jour les cellules des tableaux et de mettre
 * a jour la BDD
 */ 
function  miseAJourGrille() {
	//Slection du type de case (route, autre ou place)
	var type = recupererType();
	var id = idCasePlace;
	
	// modifier l'aspect de la cellule
	modifierAspect(id, type);

	// Mise a jour dans la BDD
	var indexes=id.split("_");
	var indexLigne=indexes[0];
	var indexColonne=indexes[1];
	miseAJourPlan (type, indexLigne, indexColonne);
}

/**
 * Cette fonction permet de faire appel  la bdd grce  l'ajax pour mettre  jour le plan du parking
 */
function miseAJourPlan(type, indexLigne, indexColonne)
{
	var parameters;
	if(type == "place")
	{
		// Recupration des informations renseignes par l'utilisateur
		var idPlace = document.getElementById("idPlace").value;
		var idCapteur = document.getElementById("idCapteur").value;
		var morphologie = document.getElementById("morphologie").value;
		var typePlace = document.getElementById("type").value;
		var handicapee = document.getElementById("handicapee").checked;
		
		// on renseigne les valeurs  rajouter dans la BDD
		parameters={idParking: idParking, idCapteur: idCapteur, idPlace: idPlace, morphologie: morphologie, typePlace: typePlace, handicapee: handicapee,
				numeroLigne: indexLigne, numeroColonne: indexColonne, idType: type};
	}  
	else {
		// on renseigne les valeurs  rajouter dans la BDD
		parameters={idParking: idParking, numeroLigne: indexLigne, numeroColonne: indexColonne, idType: type};
	}
	
	// appel  l'ajax pour mettre  jour la BDD
	$.ajax({type: 'post', dataType: 'json', url: 'miseAJourCasesParking.php', data: parameters});
}

/**
 * Cette fonction permet de mettre  jour les coordonnes du parking
 */
function miseAJourPlanParking(nbreLigne, nbreColonne)
{
	var parameters = {idParking: idParking, nbreLigne: nbreLigne, nbreColonne: nbreColonne};
	
	// appel  l'ajax pour mettre  jour la BDD
	$.ajax({type: 'post', dataType: 'json', url: 'miseAJourPlanParking.php', data: parameters});
}

/**
 * Cette fonction permet de prcharger quelques donnes du parking
 */ 
function precharger (){
	if (document.getElementById("idParking")){
		 idParking = document.getElementById("idParking").innerHTML;
	 }
	if (idParking != null){
		recupererInformationsBDD();
		document.getElementById("nbLignes").value = plan['dimensions']['nbreLignes'] + "";
		document.getElementById("nbColonnes").value = plan['dimensions']['nbreColonnes'] + "";
	}
}
///////////////////////////////////////////////////////////////////
////////////  COTE VISUALISATION PAR UTILISATEUR  /////////////////
///////////////////////////////////////////////////////////////////

/**
 * Cette fonction permet d'afficher le parking cr s'il existe, sinon en cre un nouveau
 */
 function afficherGrille (){
	if (document.getElementById("idParking")){
		idParking = document.getElementById("idParking").innerHTML;
	}
	if (idParking != null){
		recupererInformationsBDD();
		rafraichissementCellule ();
		creationGrille(false);
		var type;
		var i, j, k = 0;
		if (!plan['vide']){
			//Sinon, on affiche le tableau dj prsent
			for (i=0;i<plan['champs'].length;i++) {
				id = plan['champs'][i]['numeroLigne']+"_"+plan['champs'][i]['numeroColonne'];
				if (plan['champs'][i]['idType'] == 1){
					type = "route";
				}
				else if (plan['champs'][i]['idType'] == 2)
				{
					for (j=0; j < infoPlace.length; j++){
						if (plan['champs'][i]['idPlace'] == infoPlace[j]['idPlace']){
							k = j;
							break;
						}
					}
					type = "place";
					var cellPlay=document.getElementById(id);
					with (cellPlay) {
						title="Type de place : " + infoPlace[k]['typePlace'] + "\nMorphologie : " + infoPlace[k]['morphologie'];
					}
					if (infoPlace[k]['disponible'] == "1"){
						if (infoPlace[k]['handicapee'] == "1"){
							type = "placeHandicapeeLibre";
						}
						else {
							type = "placeLibre";
						}
					}
					else {
						type = "placeOccupee";
					}
				}
				else {
					type = "autre";
				}
				modifierAspect(id, type);
			}	
		}
	}
 }
 
 /**
  * Cette fonction permet de rafraichir la cellule
  */
  function rafraichissementCellule (){
	var parameters = {idParking: idParking};
	
	// appel  l'ajax pour mettre  jour la BDD
	$.ajax({async: false, type: 'post', dataType: 'json', url: 'recupInfosPlace.php', data: parameters, success: rafraichir});
  }
  
  /**
   * cette fonction change l'aspect de la cellule (couleur) et le titre en fonction des paramtres
   */ 
  function rafraichir (data){
	   infoPlace = data;
   }
   
/**
 * Cette fonction est appele toutes les 5 secondes pour recharger les valeurs
 */
function refresh_parking()
{
	precharger();
	afficherGrille();
	setTimeout('refresh_parking()', 5000);	
}