<?php
	/*
	 * connaître si l'id d'un capteur existe
	 */
	function idCapteurExiste($bdd, $id)
	{
		$sql = 'SELECT idCapteur FROM capteur WHERE idCapteur = :id';
		$req = $bdd->prepare ($sql);
		$req->execute(array('id' => $id));
		$resultat = $req->fetch();
		$req->closeCursor();
		if (!$resultat)
		{
			return false;
		}
		else 
		{
			return true;
		}
	}
	
	
	/*
	 * connaître l'état d'un capteur
	 */
	function capteurDisponible($bdd, $id)
	{
		$sql = 'SELECT disponible FROM capteur WHERE idCapteur = :id';
		$req = $bdd->prepare ($sql);
		$req->execute(array('id' => $id));
		if ($ligne = $req->fetch())
		{
			$resultat = $ligne['disponible'];
		}
		$req->closeCursor();
		return $resultat;
	}
	
	
	/*
	 * Cette fonction permet de changer l'état d'un capteur
	 */
	function modifierCapteur ($bdd, $table, $champCle ,$cle, $champ, $valeur)
	{
		$sql = 'UPDATE ' . $table . ' SET ' . strval($champ) . ' = :valeur WHERE ' . $champCle . '= :cle';
		$req = $bdd->prepare($sql);
		$req->execute(array(
				'cle' => strval($cle),
				'valeur' => strval($valeur)));
		$req->closeCursor();
	}
	
	/*
	 * Cette fonction permet d'ajouter une case dans la BDD
	 */
	function ajouterCapteur ($bdd, $tab){
		$sql = 'INSERT INTO capteur (idCapteur, idParking, disponible) '.
			' VALUES(:idCapteur, :idParking, 1)';
		$req = $bdd->prepare($sql);
		$req->execute(array(
				'idCapteur' => $tab['idCapteur'],
				'idParking' => $tab['idParking']));
		$req->closeCursor();
	}

?>