<?php
	/*
	 * Cette fonction renvoie le nombre de lignes de la table placée en paramètre
	 */
	function RecupNbreColonnes ($bdd, $table)
	{
		// requête sql
		$sql = 'SELECT count(*) AS nbreColonnes FROM information_schema.columns WHERE table_schema = "mgerier" and table_name= :table';
		$req = $bdd->prepare($sql);
		$req->execute(array('table' => strval($table)));
		if($ligne = $req->fetch())
		{
			// recupération du nombre de colonnes
			$nbreColonnes = $ligne['nbreColonnes'];
		}
		$req->closeCursor();
		return $nbreColonnes;
	}
	
	/*
	 * Cette fonction renvoie le nombre de lignes de la table placée en paramètre
	 */ 
	function RecupNbreLignes ($bdd, $table)
	{
		// requête sql
		$sql = 'SELECT count(*) AS nbreLignes FROM ' . strval($table);
		$req = $bdd->prepare($sql);
		$req->execute();
		if($ligne = $req->fetch())
		{
			// récupération du nombre de lignes
			$nbreLignes = $ligne['nbreLignes'];
		}
		$req->closeCursor();
		return $nbreLignes;
	}
	
	/*
	 * Cette fonction renvoie les noms des colonnes de la table placée en paramètre 
	 * sauf les valeurs placées dans le tableau en paramètre
	 */
	function recupNomsColonnes ($bdd, $table)
	{
		// requête sql
		$sql = 'DESCRIBE ' .strval($table);
		$req = $bdd->prepare($sql);
		$req->execute();
		$tab = array();
		// récupération des noms des colonnes de la table (nom placé en paramètre)
		$ligne = $req->fetchAll(PDO::FETCH_COLUMN);
		return $ligne;
	}
	
	/* 
	 * Cette fonction récupère tous les champs avec les colonnes voulues
	 */
	function recupTousLesChamps ($bdd, $table)
	{
		$message = preparationRecuperation ($bdd, $table);
		// requête sql
		$sql = 'SELECT '. $message . ' FROM ' . strval($table);
		$tab = recuperationValeurs ($bdd, $sql);
		return $tab;
	}
	
	/*
	 * Cette fonction permet de récupérer les valeurs dans un tbaleau
	 */
	 function recuperationValeurs ($bdd, $sql){
		$req = $bdd->prepare($sql);
		$req->execute();

		$i =0;
		// recupération de toutes les colonnes
		while($row = $req->fetch(PDO::FETCH_ASSOC)) {
			// recupération de toutes les lignes
			$tab[$i] = $row;
			$i++;
		}
		$req->closeCursor();
		return $tab;
	 }
	
	/*
	 * Cette fonction prépare la récupération
	 */ 
	 function preparationRecuperation ($bdd, $table){
		 // on récupère les noms des colonnes
		$nomsColonnes =  recupNomsColonnes($bdd, $table);
		$message = '';
		// on prépare la requête sql pour l'avoir dans un certains ordre
		for ($i = 0; $i < count($nomsColonnes) - 1; $i++){
			$message .= $nomsColonnes[$i] . ', ';
		}
		$message .= $nomsColonnes[count($nomsColonnes) - 1];
		return $message;
	 }
	
	/* 
	 * Cette fonction récupère tous les champs avec les colonnes voulues
	 */
	function recupTousLesChampsAvecId ($bdd, $table, $champ, $valeur){
		$message = preparationRecuperation ($bdd, $table);
		// requête sql
		$sql = 'SELECT '. $message . ' FROM ' . strval($table) . ' WHERE '. $champ . '=' . $valeur .';';
		$tab = recuperationValeurs ($bdd, $sql);
		return $tab;
		/*// on récupère les noms des colonnes
		$nomsColonnes =  recupNomsColonnes($bdd, $table);
		$message = '';
		// on prépare la requête sql pour l'avoir dans un certains ordre
		for ($i = 0; $i < count($nomsColonnes) - 1; $i++){
			$message .= $nomsColonnes[$i] . ', ';
		}
		$message .= $nomsColonnes[count($nomsColonnes) - 1];
		// requête sql
		$sql = 'SELECT '. $message . ' FROM ' . strval($table);
		$req = $bdd->prepare($sql);
		$req->execute();

		$i =0;
		// recupération de toutes les colonnes
		while($row = $req->fetch(PDO::FETCH_ASSOC)) {
			// recupération de toutes les lignes
			$tab[$i] = $row;
			$i++;
		}
		$req->closeCursor();
		return $tab;*/
	}
?>