<?php
	/*
	 * Cette fonction permet d'afficher se connecter lorsqu'il n'y a pas de session ouverte
	 * et affiche Se déconecter lorsqu'il y a une session ouverte
	 */
	function lienConnexion() 
	{
		// S'il existe une varaible de session pseudo, on retourne les liens en fonction
		if (isset($_SESSION['pseudo']))
		{
			return "<a id=\"deconnexion\" href=\"traitementDeconnexion.php\" >Se déconnecter</a>";
		}
		else 
		{
			return "<a id=\"connexion\" href=\"connexion.php\" >Se connecter</a>";
		}
	}
	
	/*
	 * Cette fonction permet de crypter le mot de passe
	 */
	function crypterPassWrd($pass)
	{
		// hachage ("cryptage") de la variable placée en paramètre 
		$resultat = sha1($pass);
		return $resultat; 
	}
	
	/* 
	 * Cette fonction retourne vrai si l'adresse mail est au bon format, faux sinon 
	 */
	function bonFormatAdresseMail($adresse){
		//Adresse mail trop longue (254 octets max)
		if(strlen($adresse)>254)
		{
			return '<p>Votre adresse est trop longue.</p>';
		}


		//Caractères non-ASCII autorisés dans un nom de domaine .eu :
		$nonASCII='ddeeeeegggghhiiiiijklll?lnnn??ooooerrrssstt';
		$nonASCII.='ddeeeeegggghhiiiiijklll?lnnn??ooooerrrssstt';
		$nonASCII.='uuuuuuwyzzzt????????aß?de??????µ???p??st?f';
		$nonASCII.='????????????????????????????????????????t';
		$nonASCII.='?????????????????????????????????????????';
		$nonASCII.='?????????????????????????????????????????';
		$nonASCII.='???????????????????????????????????????'; // note : 1 caractète non-ASCII vos 2 octets en UTF-8

		// syntaxe que doit respecter l'adresse renseignée
		$syntaxe="#^[[:alnum:][:punct:]]{1,64}@[[:alnum:]-.$nonASCII]{2,253}\.[[:alpha:].]{2,6}$#";

		// Si c'est respecté on retourne vrai, sinon on retourn faux
		if(preg_match($syntaxe,$adresse))
		{
			return true;
		}
		else
		{
			return false;
		}
	}
	
	/*
	 *Cette fonction renvoie un mot de passe aléatoire de 8 caractère
	 */ 
	function genererMDP ()
	{
		// initialiser la variable $mdp
		$mdp = "";
		$longueur = 8;
		 
		// Chaine de caractère représentant les mots de passes possibles
		$possible = "2346789bcdfghjkmnpqrtvwxyzBCDFGHJKLMNPQRTVWXYZ";
		 
		// récupération de la longueur 
		$longueurMax = strlen($possible);
		 
		if ($longueur > $longueurMax) {
			$longueur = $longueurMax;
		}
		 
		// initialiser le compteur
		$i = 0;
		 
		// ajouter un caractère aléatoire à $mdp jusqu'à ce que $longueur soit atteint
		while ($i < $longueur) {
			// prendre un caractère aléatoire
			$caractere = substr($possible, mt_rand(0, $longueurMax-1), 1);
			 
			// vérifier si le caractère est déjà utilisé dans $mdp
			if (!strstr($mdp, $caractere)) 
			{
				// Si non, ajouter le caractère à $mdp et augmenter le compteur
				$mdp .= $caractere;
				$i++;
			}
		}
		return $mdp;
	}
?>