<?php	
	/*
	 * Cette fonction permet d'ajouter une case dans la BDD
	 */
	function ajouterPlaceParking ($bdd, $tab){
		$sql = 'INSERT INTO place(idParking, idPlace, idCapteur, morphologie, typePlace, handicapee) '.
			' VALUES(:idParking, :idPlace, :idCapteur, :morphologie, :typePlace, :handicapee)';
		$req = $bdd->prepare($sql);
		$req->execute(array(
				'idParking' => $tab['idParking'],
				'idCapteur' => $tab['idCapteur'],
				'morphologie' => $tab['morphologie'],
				'typePlace' => $tab['typePlace'],
				'idPlace' => $tab['idPlace'],
				'handicapee' => $tab['handicapee']));
		$req->closeCursor();
	}
	
	/*
	 * Cette fonction permet de changer les informations de la casePlanParking dont les lignes et colonnes
	 * sont placés dans le tableau placé en paramètres
	 */
	function modifierPlaceParking ($bdd, $tab)
	{
		foreach ($tab as $champ => $valeur){
			$sql = 'UPDATE place SET ' . strval($champ) . ' = :valeur WHERE idPlace= :idPlace AND idParking= :idParking ';
			$req = $bdd->prepare($sql);
			$req->execute(array(
					'valeur' => $valeur,
					'idPlace' => $tab['idPlace'],
					'idParking' => $tab['idParking']));
			$req->closeCursor();
		}
	}
	
	/*
	 * Cette fonction supprimer une place
	 */
	function supprimerPlaceParking ($bdd, $idParking, $idPlace){
		$sql = 'DELETE FROM place WHERE idPlace= :idPlace AND idParking= :idparking ';
		$req = $bdd->prepare($sql);
		$req->execute(array(
				'idParking' => $idParking,
				'idPlace' => $idPlace));
		$req->closeCursor();
	}
	
	/*
	 * Cette fonction renvoie true si la place existe déjà, sinon renvoie false
	 */
	 function placeDejaExistante ($bdd, $idParking, $idPlace){
		$sql = 'SELECT idPlace FROM place WHERE idParking= :id AND idPlace= :idPlace';
		$req = $bdd->prepare ($sql);
		$req->execute(array(
				'id' => $idParking,
				'idPlace' => $idPlace));
		$resultat = $req->fetch();
		if(!$resultat)
		{
			$existe = false;
		}
		else 
		{
			$existe = true;
		}
		$req->closeCursor();
		return $existe;
	 }
	 
	 /*
	 * Cette fonction renvoie les informations 
	 */
	 function recupererPlace ($bdd, $idPlace, $idParking){
		$sql = 'SELECT * FROM place WHERE idParking= :idParking AND idPlace= :idPlace';
		$req = $bdd->prepare ($sql);
		$req->execute(array(
				'idParking' => $idParking,
				'idPlace' => $idPlace));
		$resultat = $req->fetch(PDO::FETCH_ASSOC);
		$req->closeCursor();
		return $resultat;
	 }
?>