<?php
	// inclusion du fichier où se trouvent les fonctions à utiliser
	include_once '../php/fonctions/casePlanParking.php';
	include_once '../php/fonctions/place.php';
	include_once '../php/fonctions/capteur.php';
	include_once '../sql/ConnexionBaseSQL.php';
	include_once '../php/fonctions/parking.php';
	
	// connexion à la BDD
	$bdd = connexionBDD();
	
	// s'il y a un problème
	if ($bdd == -1)
	{
		echo "il y a un problème";
	}
	else {
		if (isset($_REQUEST['idType'])){
			if (htmlspecialchars($_REQUEST['idType']) == "route"){
				$_REQUEST['idType'] = 1;
			}
			else if (htmlspecialchars($_REQUEST['idType']) == "place"){
				$_REQUEST['idType'] = 2;
			}
			else {
				$_REQUEST['idType'] = 3;
			}
		}
		// on récupère les paramètres envoyés
		foreach ($_REQUEST as $champ => $valeur){
			// On met les valeurs qui sont présentent dans la table casePlanParking dans le tableau
			if ($champ == "idType" || $champ == "idPlace" || $champ == "idParking" ||
				$champ == "numeroColonne" || $champ == "numeroLigne"){
					
				$tabCase[$champ] = intval(htmlspecialchars($valeur));
			}
			// Idem pour la table Place
			if ($champ == "idCapteur" || $champ == "idPlace" || $champ == "idParking"){
				$tabPlace[$champ] = intval(htmlspecialchars($valeur));
			}
			else if ($champ == "handicapee"){
				if (strval($valeur) == "true"){
					$tabPlace[$champ] = true;
				}
				else {
					$tabPlace[$champ] = false;
				}
				
			}
			else if ($champ == "morphologie" || $champ == "typePlace" ){
				$tabPlace[$champ] = strval(htmlspecialchars($valeur));
			}
		}
		
		// On met à jour les informations du parking
		if (!caseDejaExistante ($bdd, $tabCase['idParking'], $tabCase['numeroColonne'], $tabCase['numeroLigne'])){
			ajouterCasePlanParking ($bdd, $tabCase);
		}
		else {
			modifierCasePlanParking ($bdd, $tabCase);
		}
		
		
		if (!placeDejaExistante ($bdd, $tabPlace['idParking'], $tabPlace['idPlace'])){
			ajouterPlaceParking ($bdd, $tabPlace);
		}
		else {
			modifierPlaceParking ($bdd, $tabPlace);
		}
		
		if(!idCapteurExiste($bdd, $tabPlace['idCapteur'])){
			$tabCapteur['idCapteur'] = $tabPlace['idCapteur'];
			$tabCapteur['idParking'] = $tabPlace['idParking'];
			ajouterCapteur ($bdd, $tabCapteur);
		}
		modifierNbPlacesMax ($bdd, $tabPlace['idParking']);
	}
?>
