<?php
/*<!-- /////////////////////////////////////////// --!>
Cette page permet de traiter l'oubli de mot de passe.
Elle permet d'envoyer un mail à la personne.
<!-- //////////////////////////////////////////// -->*/

	// fonction de session afin de garder les variables de session
	session_start();
	
	// inlusion des fichiers où les fonctions sont utilisées
	include_once './fonctions/membre.php';
	include_once './fonctions/general.php';
	include_once '../sql/ConnexionBaseSQL.php';

	// connexion à la BDD
	$bdd = connexionBDD();
	
	// s'il existe un champs $_POST et qu'un post soit l'adresse mail
	if(isset($_POST) && isset($_POST['email']))
	{
		
		// si le champs de l'adresse mail a été rempli
		if(!empty($_POST['email']) && !empty($_POST['nom'])){
			
			// désactivation des caractère spéciaux pour balise (éviter les scripts)
			$mail = strtolower(htmlspecialchars($_POST['email']));
			$nom = htmlspecialchars($_POST['nom']);
			
			// si l'adresse mail existe dans la bdd
			if (mailDejaExistant($bdd, $mail) && ($nom == extraireIDParMail($bdd, $mail)))
			{
				// Envoi du mail
				$destinataire = $mail;
				$pseudo = extraireIDParMail($bdd, $mail); // extraction de l'id grâce ua mail
				$mdp = genererMDP (); // génération d'un mot de passe aléatoire
				$pass = crypterPassWrd ($mdp); // cryptage du mot de passe 
				$sujet = "Mot de passe oublié";
				$message = 'Bonjour,' . "\r\n\n"
							. 'Voici, vos nouveaux identifiants : ' . "\r\n"
							. '   pseudo : ' . $pseudo . "\r\n"
							. '   nouveau mot de passe :  ' . $mdp . "\r\n\n"
 							. 'Ce mail vous permet de réinitialiser votre mot de passe, cliquer'
							. 'sur le lien suivant pour réinitiliser votre mot de passe :'. "\n" .'https://mathieu.gerier.plil.net:40100/AAP/php/nouveauMdp.php'; 
							
				$entete = 'From: '.$mail."\r\n".
				'Reply-To: '.$mail."\r\n".
				'X-Mailer: PHP/'.phpversion();
				
				// Si le mail a été envoyé
				if (mail($destinataire,$sujet,$message,$entete))
				{
					// modification du mot de passe du membre dans la bdd
					modifierMembre ($bdd, $pseudo, "mdp", $pass);
					
					// creation de la variable session : pseudo
					//$_SESSION['pseudo'] = $pseudo;
					
					// redirection vers la page oubliMdpMail
					header("Location: oubliMdpMail.php?etat=256"); 
				} 
				else 
				{
					// redirection vers la page oubliMdp 
					header("Location: oubliMdpMail.php?etat=512"); 
				}
			}
			else
			{
				header("Location: oubliMdp.php?etat=16384");  
			}
		}
	}
?>