<?php
/*<!-- /////////////////////////////////////////// --!>
Cette page permet de traiter le changement de mot de 
passe d'un membre du site. changement dans la bdd.
<!-- //////////////////////////////////////////// -->*/

	// fonction de session afin de garder les variables de session
	session_start();
	
	// inlusion des fichiers où les fonctions sont utilisées
	include_once './fonctions/membre.php';
	include_once './fonctions/general.php';
	include_once '../sql/ConnexionBaseSQL.php';

	// connexion à la BDD
	$bdd = connexionBDD();
	
	// s'il existe tous les champs post suivants
	if(isset($_POST['valider_chgtMp']) && isset($_POST['oldPassword']) 
		&& isset($_POST['confPassword']) && isset($_POST['newPassword'])) 
	{	
		// désactivation des caractères spéciaux pour balises (éviter les scripts)
		$oldPass = htmlspecialchars($_POST['oldPassword']);
		$confPass = htmlspecialchars($_POST['confPassword']);
		$newPass = htmlspecialchars($_POST['newPassword']);
		
		// Si les champs de mot de passe ne sont pas null
		if($oldPass != NULL && $confPass!= null && $newPass != null) 
		{
			// cryptage du mot de passe
			$cryptOldPass = crypterPassWrd($oldPass);
			
			// récupération des id (pseudo et mdp) dans la bdd
			$tab = extraireIDAndPass($bdd, $_SESSION['pseudo']);
			
			// si les mots de passe sont différents
			if ($tab['mdp'] != $cryptOldPass)
			{
				// redirection vers la page chgtMdp
				header("Location: chgtMdp.php?etat=2048");
			}
			else 
			{
				$etat = 0;
				
				// crypotage des mots de passe
				$cryptNewPass = crypterPassWrd($newPass);
				$cryptConfPass = crypterPassWrd($confPass);
				
				// on vérifie si les mots de passe sont égaux
				if ($cryptNewPass != $cryptConfPass)
				{
					$etat += 8;
				}
				// on vérifie si le mot de passe est assez long
				if(strlen($newPass) < 4)
				{
					$etat += 16;
				}
				
				// Si la variable etat != 0, on ne peut pas mofidier le mot de passe
				if($etat != 0)
				{
					// redirection vers la page chgtMdp avec message
					$url = "chgtMdp.php?etat=". strval($etat);
					header("Location: $url");
				}
				else 
				{
					// on met à jour la bdd
					$pseudo = $_SESSION['pseudo'];
					modifierMembre ($bdd, $pseudo, "mdp", $cryptNewPass);
					
					// redirection vers la page profil
					header("Location: profil.php");
				}
			}			
		}
		else 
		{
			// redirection vers la page chgtMdp (oubli champ)
			header("Location: chgtMdp.php?etat=32");
		}
	}
	else {
		// redirection vers la page chgtMdp avec message (oubli champ)
		header("Location: chgtMdp.php?etat=32");  
	}
?>
