<?php
/*<!-- /////////////////////////////////////////// --!>
Cette page permet de traiter le changement de mot de 
passe (en cas d'oubli du dernier) d'un membre du site. 
changement dans la bdd.
<!-- //////////////////////////////////////////// -->*/

	// fonction de session afin de garder les variables de session
	session_start();
	
	// inlusion des fichiers où les fonctions sont utilisées
	include './fonctions/membre.php';
	include './fonctions/general.php';
	include '../sql/ConnexionBaseSQL.php';

	// connexion à la BDD
	$bdd = connexionBDD();
	
	// s'il existe toutes les vraibles
	if(isset($_POST['valider_newChgtMp']) && isset($_POST['pseudo']) && isset($_POST['oldPassword']) 
		&& isset($_POST['confPassword']) && isset($_POST['newPassword'])) 
	{	
		// désactivation des caractères spéciaux pour balises (éviter les scripts)
		$oldPass = htmlspecialchars($_POST['oldPassword']);
		$pseudo = htmlspecialchars($_POST['pseudo']); 
		$confPass = htmlspecialchars($_POST['confPassword']);
		$newPass = htmlspecialchars($_POST['newPassword']);
		
		// Si les champs ne sont pas vides
		if($pseudo != NULL && $oldPass != NULL && $confPass!= null && $newPass != null) 
		{
			// on crypte le mot de passe
			$cryptOldPass = crypterPassWrd($oldPass);
			
			// on extrait le pseudo et le mdp de la bdd en fonction du pseudo rentré
			$tab = extraireIDAndPass($bdd, $pseudo);
			
			// Si le mot de passe et le speudo rentrés par l'utilisateur ne corespondent
			// pas à ceux de la base de données
			if ($tab['mdp'] != $cryptOldPass  || $tab['pseudo'] != $pseudo)
			{
				// redirection vers la page nouveauMdp avec message 
				header("Location: nouveauMdp.php?etat=1024");
			}
			else 
			{
				$etat = 0;
				// on crypte les mots de passe
				$cryptNewPass = crypterPassWrd($newPass);
				$cryptConfPass = crypterPassWrd($confPass);
				
				// on vérifie s'ils ne sont pas identiques
				if ($cryptNewPass != $cryptConfPass)
				{
					$etat += 8;
				}
				// on vérifie si la longueur est correcte
				if(strlen($newPass) < 4)
				{
					$etat += 16;
				}
				
				// si la variable état != 0, on ne peut pas faire de modification suiite à une erreur
				if($etat != 0)
				{
					// redirection vers la page nouveauMdp
					$url = "nouveauMdp.php?etat=". strval($etat);
					header("Location: $url");
				}
				else 
				{
					// on crée la variable psuedo des variables de ssion
					$_SESSION['pseudo'] = $pseudo;
					
					// mise à jour de la bdd
					modifierMembre ($bdd, $pseudo, "mdp", $cryptNewPass);
					
					// redirection vers la page profil
					header("Location: profil.php");
				}
			}			
		}
		else 
		{
			// redirection vers la page nouveauMdp avec message (champ vide)
			header("Location: nouveauMdp.php?etat=32");
		}
	}
	else {
		// redirection vers la page nouveauMdp avec message (champ vide)
		header("Location: nouveauMdp.php?etat=32");  
	}
?>
