<?php
/*<!-- /////////////////////////////////////////// --!>
Cette page permet de traiter la connexion au site web en 
tant que membre.
<!-- //////////////////////////////////////////// -->*/

	// fonction de session afin de garder les variables de session
	session_start();
	
	// inlusion des fichiers où les fonctions sont utilisées
	include './fonctions/membre.php';
	include './fonctions/general.php';
	include '../sql/ConnexionBaseSQL.php';

	// connexion à la BDD
	$bdd = connexionBDD();
	
	/// On vérifie s'il existe les variables ci-dessous
	if(isset($_POST['pseudo']) && isset($_POST['password'])) 
	{	
		// désactivation des caractères spéciaux pour balise (éviter les scripts)
		$pass = htmlspecialchars($_POST['password']);
		$pseudo = htmlspecialchars($_POST['pseudo']); 
		
		// si les champs ne sont pas null
		if($pseudo != NULL && $pass != NULL) 
		{
			// on extrait les id et mots de passe de la bdd
			$tab = extraireIDAndPass($bdd, $pseudo); 
			
			// cryptage du mot de passe
			$cryptPass = crypterPassWrd($pass);
			
			// si les valeurs rentrées par l'utilisateur sont différentes de celles
			// de la bdd
			if ($tab['mdp'] != $cryptPass  || $tab['pseudo'] != $pseudo)
			{
				// redirection vers la page connexion avec message
				header("Location: connexion.php?etat=64");
			}
			else 
			{
				// creation de la varible de session pseudo
				$_SESSION['pseudo'] = $pseudo;
				
				// redirection vers la page test
				header("Location: test.php");
			}
			
		}
		else 
		{
			// redirection vers la page connexion avec message (champ vide)
			header("Location: connexion.php?etat=32");
		}
	}
	else 
	{
		// redirection vers la page connexion avec message (champ vide)
		header("Location: connexion.php?etat=32");  
	}
?>
