<?php
		require "../sql/ConnexionBaseSQL.php";
		// Connexion  la base de donnes
		$bdd = connexionBDD();
		if ($bdd == -1){
			die('Erreur : '.$e->getMessage());
		}
		
		// Vrification de la validit des informations
		// Hachage du mot de passe
		
		if (isset($_POST['inscription']))
		{
			if (isset($_POST['pseudo_inscription']) && isset($_POST['password_inscription']) 
					&& isset($_POST['confirmation_password']) && isset($_POST['mail'])){
				$verif = true;	
				$pseudo = htmlspecialchars($_POST['pseudo_inscription']);
				$password1 = htmlspecialchars($_POST['password_inscription']);
				$password2 = htmlspecialchars($_POST['confirmation_password']);
				$mail = strtolower(htmlspecialchars($_POST['mail']));
				
				$pb = '';
				// Si le pseudo existe deja
				if ($pseudo != NULL){
					$req = $bdd->prepare('SELECT pseudo FROM membres WHERE LOWER(pseudo) = :pseudo');
					$req->execute(array('pseudo' => $pseudo));
					$resultat = $req->fetch();
					if ($resultat)
					{
						$pb = 'Identifiant deja existant <br />';
					}	
					$req->closeCursor();
				}								
				else 
				{
					$pb = $pb . 'Champs Pseudo vide <br />';
				}
				
				
				// On vrifie si le mail n'existe pas dj et s'il respecte la bonne forme
				if ($mail != NULL){
					if (!VerifierAdresseMail($mail))
					{
						$pb = $pb . 'Format inconnu d\'addresse email <br />';
					}
					else 
					{
						$req = $bdd->prepare('SELECT adresse_mail FROM membres WHERE LOWER(adresse_mail) = :mail');
						$req->execute(array('mail' => $mail));
						$resultat = $req->fetch();
						if ($resultat)
						{
							$pb = $pb . 'Adresse mail dj existante <br />';
						}
						$req->closeCursor();
					}
				}
				else 
				{
					$pb = $pb . 'Champs d\'adresse mail vide <br />';
				}
				
				// verification du bon respect d'criture du mdp
				if ($password1 == NULL || $password2 == NULL)
				{
					if ($password1 == NULL)
					{
						$pb = $pb . 'Champs de Mot de passe vide <br />';
					}
					if ($password2 == NULL){
						$pb = $pb . 'Champs de Confirmation de Mot de passe vide <br />';
					}
				}
				else 
				{
					// On vrifie si les mots de passe ne sont pas identiques
					if($password1 != $password2){
						$pb = $pb . 'Mots de passe diffrents <br />';
					}
					else
					{		
						// On vrifie si la longueur du mot de passe dpasse 4 caractres
						if (strlen($password1) < 4){
							$pb = $pb . 'Mot de passe trop court<br/>';
						}
					}
				}
			}
			else 
			{
				$pb = $pb . 'Il manque un champs<br />';
			}
			
			// Si Aucun problme, on insre dans la BDD le nouvel utilisateur
			if($pb == NULL)
			{
				$pass1_hache = sha1($password1);
				$pass2_hache = sha1($password2);
				$req = $bdd->prepare('INSERT INTO membres(pseudo, mdp, adresse_mail,
					date_inscription, id_groupe) VALUES(:pseudo, :pass, :email, CURDATE(), 3)');
					$req->execute(array(
					'pseudo' => $pseudo,
					'pass' => $pass1_hache,
					'email' => $mail));
				// Effectuer ici la requte qui insre le message
				// Puis rediriger vers test.php comme ceci :
				$req->closeCursor();
				session_start();
				$_SESSION['id'] = $resultat['id'];
				$_SESSION['pseudo'] = $pseudo;
				?>
				 <meta http-EQUIV="Refresh" CONTENT="0; url=test.php">
				<?php
			}
			else 
			{
				echo $pb;
			}
		}
		elseif (isset($_POST['connexion']))
		{
			$pb = '';
			// On vrifie s'il existe des champs pour mdp et pseudo
			if (isset($_POST['pseudo_connexion']) && isset($_POST['password_connexion']))
			{	
				$pseudo = htmlspecialchars($_POST['pseudo_connexion']);
				$password = htmlspecialchars($_POST['password_connexion']);
				// On vrifie que le champs pseudo n'est pas vide
				if ($pseudo == NULL) // &&  != NULL)
				{
					$pb = $pb . 'Champs pseudo vide<br />';
				}
				elseif ($password == NULL)
				{
					$pb = $pb . 'Champs Mot de passe vide<br />';
				}
				else 
				{
					$pass_hache = sha1($password);
					// On vrifie les identifiants
					$req = $bdd->prepare('SELECT id FROM membres WHERE pseudo = :pseudo AND mdp = :pass');
					$req->execute(array(
					'pseudo' => $pseudo,
					'pass' => $pass_hache));
					$resultat = $req->fetch();
					if (!$resultat)
					{
						$pb = $pb . 'Mauvais identifiant ou mot de passe !<br />';
					}
					$req->closeCursor();
				}
			}
			else 
			{	
					$pb = $pb . 'Il manque un champs <br />';
			}
			
			if ($pb == NULL)
			{
				session_start();
				$_SESSION['id'] = $resultat['id'];
				$_SESSION['pseudo'] = $pseudo;
				echo 'Vous tes connect !';
				// Effectuer ici la requte qui insre le message
				// Puis rediriger vers test.php comme ceci :	
				?>
				 <meta http-EQUIV="Refresh" CONTENT="0; url=test.php">
				<?php
			}
			else 
			{
				echo $pb;
			}
		}

	function VerifierAdresseMail($adresse){
		//Adresse mail trop longue (254 octets max)
		if(strlen($adresse)>254)
		{
			return '<p>Votre adresse est trop longue.</p>';
		}


		//Caractres non-ASCII autoriss dans un nom de domaine .eu :

		$nonASCII='ddeeeeegggghhiiiiijklll?lnnn??ooooerrrssstt';
		$nonASCII.='ddeeeeegggghhiiiiijklll?lnnn??ooooerrrssstt';
		$nonASCII.='uuuuuuwyzzzt????????a?de?????????p??st?f';
		$nonASCII.='????????????????????????????????????????t';
		$nonASCII.='?????????????????????????????????????????';
		$nonASCII.='?????????????????????????????????????????';
		$nonASCII.='???????????????????????????????????????'; // note : 1 caractte non-ASCII vos 2 octets en UTF-8


		$syntaxe="#^[[:alnum:][:punct:]]{1,64}@[[:alnum:]-.$nonASCII]{2,253}\.[[:alpha:].]{2,6}$#";

		if(preg_match($syntaxe,$adresse))
		{
			return true;
		}
		else
		{
			return false;
		}
	}					
?>